=== debian/changelog ===
paraview (4.1.0+dfsg+1-1) unstable; urgency=medium

  * [130e468] Add python-matplotlib into Depends. (Closes: #761297)
  * [183704d] Fix FTBFS against new libjpeg. (Closes: #765939)
  * [1b234ad] Use dh_python2 instead of python-support in BD.
  * [8dea743] Update d/copyright. Remove all chm-files, fix lintian warnings.
  * [e42b9b1] Imported Upstream version 4.1.0+dfsg+1

 -- Anton Gladky <gladk@debian.org>  Mon, 20 Oct 2014 21:02:42 +0200
